#!/bin/bash

rm -rf org_repos  repos  downstream

set -ex

mkdir org_repos
mkdir repos
mkdir downstream

pushd repos
git init --bare repo1.git
git init --bare repo2.git
git init --bare repo3.git
popd

pushd org_repos
git clone ../repos/repo1.git top
cd top
echo "top first file" > file1.txt
git add file1.txt
git status
git commit -m "First top file"

git clone ../../repos/repo2.git middle
pushd middle
echo "middle first file" > file1.txt
git add file1.txt
git status
git commit -m "First middle file"

git clone ../../../repos/repo3.git bottom

pushd bottom

echo "bottom first file" > file1.txt
git add file1.txt
git status
git commit -m "First bottom commit"
git push -u origin master

popd

git submodule add ../repo3.git bottom
git add bottom
git status
git commit -m "First bottom submodule update"
git push -u origin master

popd 

git submodule add ../repo2.git middle
git add middle
git status
git commit -m "First middle submodule update"
git push -u origin master

popd

pushd downstream

git clone ../repos/repo1.git top
cd top

git submodule update --init

popd

pushd org_repos/top

pushd middle

pushd bottom

echo "bottom second file" > file2.txt
git add file2.txt
git status
git commit -m "Second bottom commit"
git push origin master

popd

git add bottom
git status
git commit -m "Second bottom submodule update"
git push origin master

popd 

git add middle
git status
git commit -m "Second middle submodule update"
git push -u origin master

popd

pushd downstream/top

echo Should not produce errors

git pull

popd

